-- $Id: Log.lua 92963 2009-06-26 02:43:09Z augusto $

local Viewer = require "loop.debug.Viewer"
local Verbose = require "loop.debug.Verbose"

---
--Mecanismo para debug do OpenBus baseado no mdulo Verbose provido pelo LOOP
---
module ("openbus.util.Log", Verbose)

-- Coloca data e hora no log
timed = "%d/%m %H:%M:%S"

-- Usa uma instncia prpria do Viewer para no interferir com o do OiL
viewer = Viewer{
           maxdepth = 2,
           indentation = "|  ",
           -- output = io.output()
         }

-- Definio dos tags que compem cada grupo
groups.basic = {"init", "warn", "error"}
groups.mechanism = {"interceptor", "lease", "conn"}
groups.core = {"scs", "member"}
groups.all = {"basic", "service", "mechanism", "core"}

-- Definio dos nveis de debug (em ordem crescente)
_M:newlevel{"basic"}
_M:newlevel{"service"}
_M:newlevel{"mechanism"}
_M:newlevel{"core"}

-- Caso seja necessrio exibir o horrio do registro
-- timed.basic =  "%d/%m %H:%M:%S"
-- timed.all =  "%d/%m %H:%M:%S"
